<script lang="ts">
	import "../app.postcss"

	import jwtDecode from "jwt-decode"
	import type { JwtPayload } from "jwt-decode"
	import { browser } from "$app/env"
	import { page, session } from "$app/stores"
	import { useAuth } from "$lib/auth"
	import type { User } from "$lib/model"
	import { userProfile } from "$lib/stores"
	import SidebarLayout from "$lib/components/SidebarLayout.svelte"
	import SidebarNavItem from "$lib/components/SidebarNavItem.svelte"

	const authRoutes = {
		login: "/login",
		loginCallback: "/login/callback",
		logout: "/logout",
	}

	const pkceConfig = browser && {
		client_id: $session.config.gitlabOauthClientId,
		redirect_uri: new URL(authRoutes.loginCallback, window.location.origin).toString(),
		authorization_endpoint: new URL("/oauth/authorize", $session.config.gitlabUrl).toString(),
		token_endpoint: new URL("/oauth/token", $session.config.gitlabUrl).toString(),
		requested_scopes: "api openid",
	}

	function createUserFromGitlabUser(gitlabUser): User {
		return {
			avatarUrl: gitlabUser.avatar_url, //TODO add default picture
			displayName: gitlabUser.name,
			profileUrl: gitlabUser.web_url,
			username: gitlabUser.username,
		}
	}

	async function onTokensLoad(tokens: unknown) {
		if (tokens === null) {
			$userProfile = null
			return
		}

		if (browser) {
			const { Gitlab } = (await import("@gitbeaker/browser")).default
			const gitlabClient = new Gitlab({
				host: $session.config.gitlabUrl,
				oauthToken: (tokens as any).access_token,
			})

			const idTokenPayload = jwtDecode<JwtPayload>((tokens as any).id_token as string)
			const gitlabUserId = parseInt(idTokenPayload.sub)
			const gitlabUser = await gitlabClient.Users.show(gitlabUserId)

			$userProfile = createUserFromGitlabUser(gitlabUser)
		}
	}

	const auth = useAuth({ authRoutes, onTokensLoad, page, pkceConfig })
</script>

<SidebarLayout>
	<svelte:fragment slot="header-right">
		{#if $userProfile !== undefined}
			{#if $userProfile === null}
				<a href={auth.buildLoginPath($page)}>Login</a>
			{:else}
				<a href="/profile" class="avatar avatar-sm">
					<img src={$userProfile.avatarUrl} alt="User avatar" />
				</a>
				<a class="ml-4" href={auth.buildLogoutPath($page)}>Logout</a>
			{/if}
		{/if}
	</svelte:fragment>

	<svelte:fragment slot="nav">
		<SidebarNavItem active={$page.path === "/"} href="/">Home</SidebarNavItem>
		<SidebarNavItem active={$page.path.startsWith("/data-packages")} href="/data-packages">
			Data Packages
		</SidebarNavItem>
	</svelte:fragment>

	<main>
		<slot />
	</main>
</SidebarLayout>
